/***********************************************************
 formcheck 
gcc -o formchk formchk.c
ۑ̃tH[}bg̃`FbN
gpF>formchk p02ex01.c 2J01
vO̕Ԃl
-1FɃt@CȂŗ^t@CȂ
0FI
1Fۑ薼CoȔԍɈُ킪
2Fɖ肪
3Fۑ薼CoȔԍɈُ킪Cɖ肪
4FbvOł͂ȂCۑ薼CoȔԍ͐
5FbvOł͂ȂBۑ薼CoȔԍُ͈
***********************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

//#define DEBUG
#define PRINT

//vOƔFgq
//  .c
//  .cpp
//  .java
int isProgram(char *fname)
{
	char *p=strstr(fname,".c\0");
	if (p==NULL) p=strstr(fname,".cpp\0");
	if (p==NULL) p=strstr(fname,".java\0");
	return (p!=NULL)?1:0;
}

void deleteRTLF(char *txt)
{
	char *p=strchr(txt,'\n');
	char *q=strchr(txt,'\r');
	if (p) *p='\0';
	if (q) *q='\0';
}

void replaceKanji(char *txt)
{
	int iskanji=0;
	while(*txt) {
		if (iskanji==0 && (*txt&0x80)) {
			*txt='.';
			iskanji=1;
		} else if (iskanji) {
			*txt='.';
			iskanji=0;
		}
		txt++;
	}
}

//txt[hwordŎn܂Ă邩ǂ`FbN
//1: n܂Ă@0: ł͂Ȃ
//[hƂworďɉpqĂȂ
int chackStratWord(char *txt, char *word)
{
	char ch;
	if (strstr(txt,word)!=txt) return 0;
	ch=txt[strlen(word)];
	if (isalnum(ch)) return 0;
	return 1;
}

void replaceDQ(char *txt)
{
	char *p;
	p=txt;
	while (p=strstr(txt,"\\\"")) {
		*p++='.';
		*p++='.';
	}
	p=txt;
	while (p=strstr(txt,"'{'")) {
		p++;
		*p++='.';
	}
	p=txt;
	while (p=strstr(txt,"'}'")) {
		p++;
		*p++='.';
	}
}

void removeStaticString(char *txt)
{
	char *p1,*p2;
	p1=txt;
	while (p1=strchr(p1,'\"')) {
		p2=strchr(p1+1,'\"');
		if (p2) {
			p2++;
			while (p1<p2) {
				*p1++='.';
			}
			p1=p2;
		} else {
			return;
		}
	}
}

void removeCComment(char *txt)
{
	char *p1,*p2;
	p1=txt;
	while (p1=strstr(p1,"/*")) {
		p2=strstr(p1+1,"*/");
		if (p2) {
			p2+=2;
			while (p1<p2) {
				*p1++=' ';
			}
			p1=p2;
		} else {
			return;
		}
	}
}

void removeCppComment(char *txt)
{
	char *p=strstr(txt,"//");
	if (p) *p='\0';
}

void removeSharpCommand(char *txt)
{
	char *p=txt;
	while (*p=='\t' || *p==' ') p++;
	if (*p=='#') *txt='\0';
}

void removeBlankLine(char *txt)
{
	char *p=txt;
	while (*p=='\t' || *p==' ') p++;
	if (!*p) *txt='\0';
}

//sɂ킽Rg̊Jn
int removeCComment1(char *txt)
{
	char *p=strstr(txt,"/*");
	if (p) {
		*p='\0';
		return 1; //
	} else {
		return 0; //Ȃ
	}
}

//sɂ킽Rg̏I[
int removeCComment2(char *txt)
{
	char *p=strstr(txt,"*/");
	if (p) {
		*p='\0';
		p+=2;
		while (*p) {
			*txt++=*p++;
		}
		*txt='\0';
		return 0; //
	} else {
		return 1; //Ȃ
	}
}

void removeRightSpace(char *txt)
{
	char *p=txt;
	while (*p) p++;
	p--;
	while (txt<=p && (*p=='\t' || *p==' ')) {
		*p='\0';
		p--;
	}
}

//s{}菜
void removeBracePair(char *txt)
{
	char *p1,*p2;
	int i;
	for (i=0;i<3;i++) {
		p1=txt;
		while (p1=strchr(p1,'{')) {
			p2=strchr(p1+1,'}');
			if (p2) {
				*p1='.';
				*p2='.';
				p1=p2;
			} else {
				break;
			}
		}
	}
}

//{}ɂCfg[̕ωԂ
int checkBraces(char *txt)
{
	char *p;
	int level=0;
	p=txt;
	while (*p) {
		if (*p=='{') level++;
		else if (*p=='}') level--;
		p++;
	}
	return level;
}

//@} else {ɂÕ`FbN
//@} else if (xxxxxxxxx) {ɂÕ`FbN
// ߂l@1:@0:Ȃ
int checkDoubleBraces(char *txt)
{
	char *p;
	int found=0;
	p=txt;
	while (*p) {
		if (*p=='}') found=1;
		p++;
		if (found) break;
	}
	while (*p) {
		if (*p=='{') found=2;
		p++;
		if (found==2) break;
	}
	if (found==2) return 1;
	else return 0;
}

//()ɂCfg[̕ωԂ
int checkParentheses(char *txt)
{
	char *p;
	int level=0;
	p=txt;
	while (*p) {
		if (*p=='(') level++;
		else if (*p==')') level--;
		p++;
	}
	return level;
}

//s̃Cfg̕܂̓Cfg̃Xy[X
//1`:indentspacegp@100:indenttabgp
int findSpace(char *txt)
{
	int count=0;
	if (*txt=='\t') {
		count = 100;
	} else {
		while (*txt==' ') {
			count++;
			txt++;
		}
	}
	return count;
}

//^ꂽs̃Cfg̐[𐔂ĕԂ֐
//CfgXy[XōsĂCspace̒萔{łȂ΃G[
//G[̓Cfg̐[-1{Ԃ
int countIndent(int space, char *txt)
{
	int count=0;
	if (space==100) {//CfgTAB
		while (*txt++=='\t') count++;
		txt--;
		if (*txt==' ') count=-count;
	} else {
		while (*txt++==' ') count++;
		if (count%space!=0) count=-count/space;
		else count/=space;
	}
	return count;
}
/* ̂悤ȗOKƂł邽߂ɔzC̐ԂƂɂ@20130531
int xxxx[]={
	1234,2345,3456,4567,
	 123,2345,3456,4567
};
*/

void toLowerCase(char *txt)
{
	while (*txt) {
		*txt=tolower(*txt);
		txt++;
	}
}

void toUpperCase(char *txt)
{
	while (*txt) {
		*txt=toupper(*txt);
		txt++;
	}
}

int isfunctionheaderror(char *buff)
{
	char *p,*q;
	p=strchr(buff,'(');
	if (p) p=strchr(buff,')');
	if (p) p=strchr(buff,'{');
	if (p) return 1;
	else return 0;
}

//str̍̋󔒂菜trimd
void trimLeft(char *str, char *trimd)
{
	while(*str==' ' || *str=='\t') str++;
	while(*str) *trimd++=*str++;
	*trimd='\0';
}

char *strchrr(char *str,char ch)
{
	char *p,*p1;
	p=strchr(str,ch);
	if (p==NULL) return NULL;
	do {
		p1=p;
		p++;
		p=strchr(p,ch);
	} while (p!=NULL);
	return p1;
}

char *setfname(char str[])
{
	char *p1,*p2;
	p1=strchrr(str,'\\');
	p2=strchrr(str,'/');
	if (p1!=NULL) {
		if (p2!=NULL) {
			if (p1<p2) {
				if (*(p2+1)!='\0') return p2+1;
				else return str;
			} else {
				if (*(p1+1)!='\0') return p1+1;
				else return str;
			}
		} else {
			if (*(p1+1)!='\0') return p1+1;
			else return str;
		}
	} else if (p2!=NULL) {
		if (*(p2+1)!='\0') return p2+1;
		else return str;
	} else {
		return str;
	}
}

char buff[2048];
char trimbuff[2048]; //̃Xy[X菜s
char buffp[2048]; //͂ꂽ܂܂̍sۑ

//CfgɎgĂXy[X̐Ԃ
//0:CfgSȂ
//1,2,..,n,..99:CfgɎgĂXy[X̐=n
//100:^ugĂ
int getIndentationlevel(FILE *fp)
{
	int space=0;
	int numberLines=0; //sԍ@ŏ̍s͂P
	int CComment=0; //sɂ킽Rg͒ł
	int t1;
	int indentlevel=0;
	int indentstat[]={0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0};
	int tabcount=0; //擪tabŎn܂Ăs
	int i;
	fseek(fp,0L, SEEK_SET);
	while (0<fgets(buff,2047,fp)) {
		numberLines++;
		deleteRTLF(buff);         //s\n
		strcpy(buffp,buff);
		replaceKanji(buff);       //SJISR[hi2oCgju..vɕύX
		replaceDQ(buff);          //u\"vu..vɕύX
		removeStaticString(buff); //1śu"vň͂܂ꂽÓȈ
		removeCComment(buff);     //1s/*EE*/`̃Rg폜
		removeCppComment(buff);   //u//ṽRg폜
		removeSharpCommand(buff); // #Ŏn܂s̍폜
		/*puts(buff);*/
		if (CComment==0) { //sɂ킽Rg͒łȂ
			CComment=removeCComment1(buff);
		} else { //sɂ킽Rg͒ł
			CComment=removeCComment2(buff);
			if (CComment) buff[0]='\0';
		}
		removeRightSpace(buff); //E[ɂXy[X菜
		removeBracePair(buff); //s{}菜
		removeBlankLine(buff); //Xy[XłłĂs󔒍sɂ
		if (!buff[0]) continue;

		if (strchr(buff,'}')) indentlevel--;
		if (0<indentlevel) {
			t1=findSpace(buff);
			if (t1==100) {
				tabcount++;
			} else if (t1<20) { //s̃Xy[X̌̕pxJEg
				indentstat[t1]++;
			}
		}
		if (strchr(buff,'{')) indentlevel++;
	}
	for (i=1; i<20; i++) {
		//printf("i=%d istat[i]=%d istat[i+1]%d\n",i,indentstat[i],indentstat[i+1]);
		if (indentstat[i]>indentstat[i+1]) {
			space=i;
			break;
		}
	}
	if (indentstat[0]<tabcount && indentstat[space]<tabcount) {
		space=100; //tabgĂ
	} else if (indentstat[space]<indentstat[0]) {
		space=0;
	}
	//printf("a space=%d\n",space);
	return space;
}


//Cfg̃`FbN 0FG[Ȃ@1FCfgG[
//space =100̂ƂC^uɂCfg
//space =1..n..99̂ƂCXy[XnɂCfg
int checkIndentation(FILE *fp,int space)
{
	int numberLines=0; //sԍ@ŏ̍s͂P
	int CComment=0; //sɂ킽Rg͒ł
	int exception;   //@} else {ɂOCcase,defaultɂO
	int switchexception=0;  //switch\̂܂O
	int indentLevel=0; //Cfg̃x@ŏ͂O
	int tmpindent=0;   //u(vɂꎞIȃCfg̗L
	int indent[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};//1Cfg̐[
	int indentptr=0;//1Cfg̐[zŎɃZbgׂvfw|C^
	int indenterror=0;
	int t1,t2,t3;
	fseek(fp,0L, SEEK_SET);
	numberLines=0;
	while (0<fgets(buff,2047,fp)) {
		numberLines++;
		deleteRTLF(buff);         //s\n
		strcpy(buffp,buff);
		replaceKanji(buff);       //SJISR[hi2oCgju..vɕύX
		replaceDQ(buff);          //u\"vu..vɕύX
		removeStaticString(buff); //1śu"vň͂܂ꂽÓȈ
		removeCComment(buff);     //1s/*EE*/`̃Rg폜
		removeCppComment(buff);   //u//ṽRg폜
		removeSharpCommand(buff); // #Ŏn܂s̍폜
		/*puts(buff);*/
		if (CComment==0) { //sɂ킽Rg͒łȂ
			CComment=removeCComment1(buff);
		} else { //sɂ킽Rg͒ł
			CComment=removeCComment2(buff);
			if (CComment) buff[0]='\0';
		}
		removeRightSpace(buff); //E[ɂXy[X菜
		removeBracePair(buff); //s{}菜
		removeBlankLine(buff); //Xy[XłłĂs󔒍sɂ
		if (!buff[0]) continue;

		t1=checkBraces(buff); //{}ɂCfg̕ω@̍s
		t2=checkParentheses(buff); //()ɂCfg̕ω@̍s
		t3=countIndent(space,buff); //buff̃Cfg[t3
		//printf("hello t3=%d\n",t3);

		exception=checkDoubleBraces(buff); //} else {̂悤ȍ\1
		trimLeft(buff,trimbuff);
		if (t3<0) {
			if (isdigit(trimbuff[0])||trimbuff[0]=='-') {
				t3=-t3;
			} else {
				#ifdef  PRINT
				//printf("indentation error at [%d] %s\n",numberLines,buffp);
				printf("G[ [%d] s %s ",numberLines,buffp);
				#endif
				indenterror=1;
				break;
			}
		}
		if (switchexception==0 && chackStratWord(trimbuff,"switch")) switchexception=1; //̍ŝ
		if (chackStratWord(trimbuff,"case") || chackStratWord(trimbuff,"default")) {
			exception=1;
			if (switchexception==1) {
				if (indentLevel+1==t3) {
					indent[indentptr++]=2;
					indentLevel+=2;
				} else {
					indent[indentptr++]=1;
					indentLevel+=1;
				}
				switchexception=0;
			}
		}
		if (t1==-1) {
			indentLevel-=indent[--indentptr];
			indent[indentptr]=0;
		}
		//printf("[%d] s %s indentLevel=%d exception=%d t3=%d t1=%d swex=%d\n",numberLines,trimbuff,indentLevel,exception,t3,t1,switchexception);
		if (tmpindent==0 && indentLevel-exception != t3) {
			#ifdef  PRINT
			//printf("indentation error at [%d] %s\n",numberLines,buffp);
			//printf("G[B [%d] s %s indentLevel=%d exception=%d t3=%d\n",numberLines,buffp,indentLevel,exception,t3);
			printf("G[ [%d] s %s ",numberLines,buffp);
			indenterror=1;
			#endif
			break;
		}
		/*͋Ƃɂ20150325
		if (indentLevel==0) {
			if (isfunctionheaderror(buff)) indenterror=1;
		}
		*/
		if (t1==1) {
			if (switchexception==0) {
				indent[indentptr++]=1;
				indentLevel++;
			}
		} else if (t1==0) {
			//ȂɂȂ
		} else if (t1<-1 || 1<t1){
			//͖Ή
		}
		tmpindent+=t2;
		#ifdef DEBUG
		strcat(buff,"$");puts(buff);
		printf("switchexception=%d\n",switchexception);
		#endif
	}
	return indenterror;
}

int main(int argc, char *argv[])
{
	FILE *fp;
	int ret=0;
	int isPrg=0; //Ώۃt@CvOł
	int Titlefound=0; //^Cg@ŏ͂O
	int IDfound=0;    //oȔԍ@ŏ͂O
	int numberLines=0; //sԍ@ŏ̍s͂P
	int space; // 0:Cfg@1`20:indentspacegp@100:indenttabgp
				 // -1:͎Ɍ蔭
	int indenterror=0;
	char *ptr;
	char LCID[32],UCID[32];
	char *fname;

	if (argc<2) {
		#ifdef PRINT
		printf("error .. no filename\n");
		#endif
		exit(-1);
	} else if (argc<3) {
		#ifdef PRINT
		printf("error .. no filename or no studentID\n");
		#endif
		exit(-1);
	}
	if ( (fp=fopen(argv[1],"r")) == NULL ) {
		#ifdef  PRINT
		printf("error .. can't open [%s]\n",argv[1]);
		#endif
		exit(-1);
	}
	isPrg=isProgram(argv[1]);
	fname=setfname(argv[1]);
	#ifdef DEBUG
	puts(argv[1]);
	#endif
	strcpy(LCID,argv[2]);
	toLowerCase(LCID);
	strcpy(UCID,argv[2]);
	toUpperCase(UCID);
	while (0<fgets(buff,2047,fp)) { //ID Titlẽ`FbN
		numberLines++;
		if (numberLines<6) {
			if (strstr(buff,fname)) Titlefound=1;
			if (argc==3 && strstr(buff,UCID)) IDfound=1;
			if (argc==3 && strstr(buff,LCID)) IDfound=1;
			if (argc==2) {
				ptr=strrchr(argv[1],'\\');
				if (ptr && strstr(buff,ptr+1)) Titlefound=1;
			}
		}
	}
	if (isPrg) { //ނ̃`FbN
		space=getIndentationlevel(fp);
		//printf("space=%d\n",space);
		if (space==0) {
			#ifdef  PRINT
			//printf("indentation error (without indentation)\n");
			printf("G[ ()\n");
			#endif
			indenterror=1;
		} else {
			indenterror=checkIndentation(fp,space);
			if (indenterror) {
				if (space==100) {
					printf("(F^ugpŋLq)\n");
				} else {
					printf("(FXy[X%dgpŋLq)\n",space);
				}
			}
		}
	}
	

	if (isPrg) { //CvO
		if (!(Titlefound&&IDfound) && indenterror) ret=3;
		else if (!(Titlefound&&IDfound)) ret=1;
		else if (indenterror) ret=2;
	} else { //CvOł͂Ȃ
		if (!(Titlefound&&IDfound)) ret=5;
		else ret=4;
	}

	#ifdef  PRINT
	//puts(isPrg?"[is C program]":"[is not C program]");
	puts(isPrg?"[̓vOł]":"[̓vOł͂܂]");
	//puts(Titlefound?"[Proper Title found (OoO)]":"[No Proper Title found (?_?)]");
	puts(Titlefound?"[薼܂܂Ă܂ (OoO)]":"[sȑ薼܂܂Ă܂ (?_?)]");
	if (argc==3) {
		//puts(IDfound?"[Proper ID found (OoO)]":"[No Proper ID found (?_?)]");
		puts(IDfound?"[ID܂܂Ă܂ (OoO)]":"[sID܂܂Ă܂ (?_?)]");
	}
	//puts(indenterror?"[Improper Indent Format (?_?)]":"[Proper Indent Format (OoO)]");
	puts(indenterror?"[sȎ܂܂Ă܂ (?_?)]":"[ł (OoO)]");
	printf("return with %d\n",ret);
	#endif
//	getch();
	return ret;
}



/*
memo
() parentheses, round brackets - 
[] box brackets - 
{} braces, curly brackets 

\\\ߍ\͂Ă
*/
